]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - tools/build/beinstall.sh
THIS BRANCH IS OBSOLETE, PLEASE READ:
[FreeBSD/FreeBSD.git] / tools / build / beinstall.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2016 Will Andrews
4 # All rights reserved.
5 #
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions
8 # are met:
9 # 1. Redistributions of source code must retain the above copyright
10 #    notice, this list of conditions and the following disclaimer 
11 #    in this position and unchanged.
12 # 2. Redistributions in binary form must reproduce the above copyright
13 #    notice, this list of conditions and the following disclaimer in the
14 #    documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
17 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
18 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
19 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
20 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
21 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
22 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
23 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
24 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
25 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
26 #
27 # $FreeBSD$
28 #
29 ##
30 # Install a boot environment using the current FreeBSD source tree.
31 # Requires a fully built world & kernel.
32 #
33 # Non-base tools required: pkg
34 #
35 # In a sandbox for the new boot environment, this script also runs etcupdate
36 # and pkg upgrade automatically in the sandbox.  Upon successful completion,
37 # the system will be ready to boot into the new boot environment.  Upon
38 # failure, the target boot environment will be destroyed.  In all cases, the
39 # running system is left untouched.
40 #
41 ## Usage:
42 # beinstall [optional world/kernel flags e.g. KERNCONF]
43 #
44 ## User modifiable variables - set these in the environment if desired.
45 # Utility to manage ZFS boot environments.
46 BE_UTILITY="${BE_UTILITY:-"bectl"}"
47 # If not empty, 'pkg upgrade' will be skipped.
48 NO_PKG_UPGRADE="${NO_PKG_UPGRADE:-""}"
49 # Config updater - 'etcupdate' and 'mergemaster' are supported.  Set to an
50 # empty string to skip.
51 CONFIG_UPDATER="${CONFIG_UPDATER:-"etcupdate"}"
52 # Flags for etcupdate if used.
53 ETCUPDATE_FLAGS="${ETCUPDATE_FLAGS:-"-F"}"
54 # Flags for mergemaster if used.
55 MERGEMASTER_FLAGS="${MERGEMASTER_FLAGS:-"-iFU"}"
56
57
58 ########################################################################
59 ## Functions
60 cleanup() {
61         [ -z "${cleanup_commands}" ] && return
62         echo "Cleaning up ..."
63         for command in ${cleanup_commands}; do
64                 ${command}
65         done
66 }
67
68 errx() {
69         cleanup
70         echo "error: $@"
71         exit 1
72 }
73
74 rmdir_be() {
75         chflags -R noschg ${BE_MNTPT}
76         rm -rf ${BE_MNTPT}
77 }
78
79 unmount_be() {
80         mount | grep " on ${BE_MNTPT}" | awk '{print $3}' | sort -r | xargs -t umount -f
81 }
82
83 copy_pkgs() {
84         # Before cleaning up, try to save progress in pkg(8) updates, to
85         # speed up future updates.  This is only called on the error path;
86         # no need to run on success.
87         echo "Rsyncing back newly saved packages..."
88         rsync -av --progress ${BE_MNTPT}/var/cache/pkg/. /var/cache/pkg/.
89 }
90
91 cleanup_be() {
92         # Before destroying, unmount any child filesystems that may have
93         # been mounted under the boot environment.  Sort them in reverse
94         # order so children are unmounted first.
95         unmount_be
96         # Finally, clean up any directories that were created by the
97         # operation, via cleanup_be_dirs().
98         if [ -n "${created_be_dirs}" ]; then
99                 chroot ${BE_MNTPT} /bin/rm -rf ${created_be_dirs}
100         fi
101         ${BE_UTILITY} destroy -F ${BENAME}
102 }
103
104 create_be_dirs() {
105         echo "${BE_MNTPT}: Inspecting dirs $*"
106         for dir in $*; do
107                 curdir="$dir"
108                 topdir="$dir"
109                 while :; do
110                         [ -e "${BE_MNTPT}${curdir}" ] && break
111                         topdir=$curdir
112                         curdir=$(dirname ${curdir})
113                 done
114                 [ "$curdir" = "$dir" ] && continue
115
116                 # Add the top-most nonexistent directory to the list, then
117                 # mkdir -p the innermost directory specified by the argument.
118                 # This way the least number of directories are rm'd directly.
119                 created_be_dirs="${topdir} ${created_be_dirs}"
120                 echo "${BE_MNTPT}: Created ${dir}"
121                 mkdir -p ${BE_MNTPT}${dir} || return $?
122         done
123         return 0
124 }
125
126 update_mergemaster_pre() {
127         ${MERGEMASTER_CMD} -p -m ${srcdir} -D ${BE_MNTPT} -t ${BE_MM_ROOT} ${MERGEMASTER_FLAGS}
128 }
129
130 update_mergemaster() {
131         ${MERGEMASTER_CMD} -m ${srcdir} -D ${BE_MNTPT} -t ${BE_MM_ROOT} ${MERGEMASTER_FLAGS}
132 }
133
134 update_etcupdate_pre() {
135         ${ETCUPDATE_CMD} -p -s ${srcdir} -D ${BE_MNTPT} ${ETCUPDATE_FLAGS} || return $?
136         ${ETCUPDATE_CMD} resolve -D ${BE_MNTPT} || return $?
137 }
138
139 update_etcupdate() {
140         chroot ${BE_MNTPT} \
141                 ${ETCUPDATE_CMD} -s ${srcdir} ${ETCUPDATE_FLAGS} || return $?
142         chroot ${BE_MNTPT} ${ETCUPDATE_CMD} resolve
143 }
144
145
146 # Special command-line subcommand that can be used to do a full cleanup
147 # after a manual post-mortem has been completed.
148 postmortem() {
149         [ -n "${BENAME}" ] || errx "Must specify BENAME"
150         [ -n "${BE_MNTPT}" ] || errx "Must specify BE_MNTPT"
151         echo "Performing post-mortem on BE ${BENAME} at ${BE_MNTPT} ..."
152         unmount_be
153         rmdir_be
154         echo "Post-mortem cleanup complete."
155         echo "To destroy the BE (recommended), run: ${BE_UTILITY} destroy ${BENAME}"
156         echo "To instead continue with the BE, run: ${BE_UTILITY} activate ${BENAME}"
157 }
158
159 if [ -n "$BEINSTALL_CMD" ]; then
160         ${BEINSTALL_CMD} $*
161         exit $?
162 fi
163
164 if [ "$(basename -- "${BE_UTILITY}")" = "bectl" ]; then
165         ${BE_UTILITY} check || errx "${BE_UTILITY} sanity check failed"
166 fi
167
168 cleanup_commands=""
169 trap 'errx "Interrupt caught"' HUP INT TERM
170
171 [ "$(whoami)" != "root" ] && errx "Must be run as root"
172
173 [ ! -f "Makefile.inc1" ] && errx "Must be in FreeBSD source tree"
174 srcdir=$(pwd)
175 objdir=$(make -V .OBJDIR 2>/dev/null)
176 [ ! -d "${objdir}" ] && errx "Must have built FreeBSD from source tree"
177
178 ## Constants
179 ETCUPDATE_CMD="${srcdir}/usr.sbin/etcupdate/etcupdate.sh"
180 MERGEMASTER_CMD="${srcdir}/usr.sbin/mergemaster/mergemaster.sh"
181
182 # May be a worktree, in which case .git is a file, not a directory.
183 if [ -e .git ] ; then
184     commit_time=$(git show --format='%ct' 2>/dev/null | head -1)
185     [ $? -ne 0 ] && errx "Can't lookup git commit timestamp"
186     commit_ts=$(date -r ${commit_time} '+%Y%m%d.%H%M%S')
187 elif [ -d .svn ] ; then
188       if [ -e /usr/bin/svnlite ]; then
189         svn=/usr/bin/svnlite
190       elif [ -e /usr/local/bin/svn ]; then
191         svn=/usr/local/bin/svn
192       else
193         errx "Unable to find subversion"
194       fi
195       commit_ts="$( "$svn" info --show-item last-changed-date | sed -e 's/\..*//' -e 's/T/./' -e 's/-//g' -e s'/://g' )"
196     [ $? -ne 0 ] && errx "Can't lookup Subversion commit timestamp"
197 else
198     errx "Unable to determine source control type"
199 fi
200
201 commit_ver=$(${objdir}/bin/freebsd-version/freebsd-version -u 2>/dev/null)
202 [ -z "${commit_ver}" ] && errx "Unable to determine FreeBSD version"
203
204 BENAME="${commit_ver}-${commit_ts}"
205
206 BE_TMP=$(mktemp -d /tmp/beinstall.XXXXXX)
207 [ $? -ne 0 -o ! -d ${BE_TMP} ] && errx "Unable to create mountpoint"
208 [ -z "$NO_CLEANUP_BE" ] && cleanup_commands="rmdir_be ${cleanup_commands}"
209 BE_MNTPT=${BE_TMP}/mnt
210 BE_MM_ROOT=${BE_TMP}/mergemaster # mergemaster will create
211 mkdir -p ${BE_MNTPT}
212
213 ${BE_UTILITY} create ${BENAME} >/dev/null || errx "Unable to create BE ${BENAME}"
214 [ -z "$NO_CLEANUP_BE" ] && cleanup_commands="cleanup_be ${cleanup_commands}"
215
216 ${BE_UTILITY} mount ${BENAME} ${BE_TMP}/mnt || errx "Unable to mount BE ${BENAME}."
217
218 echo "Mounted ${BENAME} to ${BE_MNTPT}, performing install/update ..."
219 make "$@" DESTDIR=${BE_MNTPT} installkernel || errx "Installkernel failed!"
220 if [ -n "${CONFIG_UPDATER}" ]; then
221         "update_${CONFIG_UPDATER}_pre"
222         [ $? -ne 0 ] && errx "${CONFIG_UPDATER} (pre-world) failed!"
223 fi
224
225 # Mount the source and object tree within the BE in order to account for any
226 # changes applied by the pre-installworld updater.  Cleanup any directories
227 # created if they didn't exist previously.
228 create_be_dirs "${srcdir}" "${objdir}" || errx "Unable to create BE dirs"
229 mount -t nullfs "${srcdir}" "${BE_MNTPT}${srcdir}" || errx "Unable to mount src"
230 mount -t nullfs "${objdir}" "${BE_MNTPT}${objdir}" || errx "Unable to mount obj"
231 mount -t devfs devfs "${BE_MNTPT}/dev" || errx "Unable to mount devfs"
232
233 chroot ${BE_MNTPT} make "$@" -C ${srcdir} installworld || \
234         errx "Installworld failed!"
235
236 if [ -n "${CONFIG_UPDATER}" ]; then
237         "update_${CONFIG_UPDATER}"
238         [ $? -ne 0 ] && errx "${CONFIG_UPDATER} (post-world) failed!"
239 fi
240
241 if which rsync >/dev/null 2>&1; then
242         cleanup_commands="copy_pkgs ${cleanup_commands}"
243 fi
244
245 BE_PKG="chroot ${BE_MNTPT} env ASSUME_ALWAYS_YES=true pkg"
246 if [ -z "${NO_PKG_UPGRADE}" ]; then
247         ${BE_PKG} update || errx "Unable to update pkg"
248         ${BE_PKG} upgrade || errx "Unable to upgrade pkgs"
249 fi
250
251 if [ -n "$NO_CLEANUP_BE" ]; then
252         echo "Boot Environment ${BENAME} may be examined in ${BE_MNTPT}."
253         echo "Afterwards, run this to cleanup:"
254         echo "  env BENAME=${BENAME} BE_MNTPT=${BE_MNTPT} BEINSTALL_CMD=postmortem $0"
255         exit 0
256 fi
257
258 unmount_be || errx "Unable to unmount BE"
259 rmdir_be || errx "Unable to cleanup BE"
260 ${BE_UTILITY} activate ${BENAME} || errx "Unable to activate BE"
261 echo
262 ${BE_UTILITY} list
263 echo
264 echo "Boot environment ${BENAME} setup complete; reboot to use it."